#!/usr/bin/perl

# allsingingsubs.pl. Do not edit this file
# Edit conf.pl to change settings


sub clean_tag {
  $tag =~ /<\/?([^ >]*)/;
  $html_tag = uc $1;
  foreach $valid_tag (@valid_tags) {
      if($html_tag eq $valid_tag) {
	  return $tag;
      }
  }
  print "Rejected tag: contains $html_tag tag.<br>\n";
  return "";
}

# unescape URL-encoded data (from CGI.pm)
sub unescape {
    shift() if ref($_[0]);
    my $todecode = shift;
    return undef unless defined($todecode);
    $todecode =~ tr/+/ /;       # pluses become spaces
    $todecode =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
    return $todecode;
}

# URL-encode data (from CGI.pm)
sub escape {
    shift() if ref($_[0]) || $_[0] eq $DefaultClass;
    my $toencode = shift;
    return undef unless defined($toencode);
    $toencode=~s/([^a-zA-Z0-9_.-])/uc sprintf("%%%02x",ord($1))/eg;
    return $toencode;
}


sub process_form {

    
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

    #Find the boundary value
    $ENV{CONTENT_TYPE} =~ /boundary=\"?([^\";]+)\"?/;
    $boundary = $1;

    #Split at each boundary
    @data = split /-*$boundary-*/,$buffer;

    foreach $block (@data) {
	if($block =~ /name=\"?([^\";]*)\"?\s*/) {
	    $key = $1;
	    $' =~ /\s*$/;
	    $INPUT{$key} = $`;
	}
    }
    
    print "Content-type: text/html\n\n";
    
    $thetext = $INPUT{thetext};
    
    if($INPUT{query} eq "Preview") {

	print "<HEAD><BASE href=$base><title>Preview</title></HEAD>\n";
	
	print "<HTML><BODY>\n<p align=center><table width=500 border=0
cellpadding=0 cellspacing=0><tr><td>$man_view";
	
	print "File: $myfile<br>\n";
	
	# Lets check those tags
	$oldtext = $thetext;
	@tags = split /(<[^>]*>)/, $thetext;
	$thetext = "";
	foreach $tag (@tags) {
	    if($tag =~ /<[^>]*>/) {
		$tag = &clean_tag;
	    }
	    $thetext = $thetext . $tag;
	}
	# $thetext should now be clean
	
	$enc_thetext = &escape($thetext);
	$enc_oldtext = &escape($oldtext);
	
	print "<FORM action=$myscript method=\"POST\" enctype=\"multipart/form-data\">\n";

	#As browsers don't like long strings cut this up into 256 byte chunks

	@a_enc_thetext = split(/(.{256})/,$enc_thetext);
	@a_enc_oldtext = split(/(.{256})/,$enc_thetext);

	#Print each none blank line in its own hidden field
	$i=0;
	foreach $line (@a_enc_thetext) {
	    if($line) {
		print "<INPUT type=hidden name=enc_thetext$i value=$line>\n";
		$i++;
	    }
	}
	$i=0;
	foreach $line (@a_enc_oldtext) {
	    if($line) {
		print "<INPUT type=hidden name=enc_oldtext$i value=$line>\n";
		$i++;  
	    }
	}
	print "<INPUT type=submit name=query value=Save>\n";
	print "<INPUT type=submit name=query value=Cancel>\n";
	print "</tr></td></table></FORM>\n";
	
	print "<HR width=500><P><blockquote>\n"; 
	print $thetext;
	print "\n</blockquote></BODY> </HTML>\n"; 
	exit;
    }

    if($INPUT{query} eq "Save") {
	#Rebuild $enc_thetext form parts
	$i=0;
	$enc_thetext = "";
	$key = "enc_thetext$i";
	while($INPUT{$key}) {
	    $enc_thetext = $enc_thetext . $INPUT{$key};
	    $i++;
	    $key = "enc_thetext$i";
	}
	$thetext = &unescape($enc_thetext);
	open(MYFILE,">$myfile") or die "Cannot open file: $!";
 flock(MYFILE, 2) or die "Cannot lock file exclusively: $!";
 print MYFILE "$thetext";
	close(MYFILE) or die "Cannot close file: $!";
    }
    
    if($INPUT{query} eq "Cancel") {
	#Rebuild $enc_oldtext form parts
	$i=0;
	$enc_oldtext = "";
	$key = "enc_oldtext$i";
	while(defined($INPUT{$key})) {
	    $enc_oldtext = $enc_oldtext . $INPUT{$key};
	    $i++;
	    $key = "enc_oldtext$i";
	}
	$thetext = &unescape($enc_oldtext);
    }
    
    
    if($INPUT{query} eq "Revert") {
	open(MYFILE,$myfile) or die "Cannot open file: $!";
 @allfile = <MYFILE>;
	close(MYFILE) or die "Cannot close file: $!";
	$thetext = join "",@allfile;
    }
    
    print "\n<HTML>\n";
    print "<title>Edit</title>\n";
    print "<BODY background=\"$bg_img\" bgcolor=#FFFFFF text=#000000>\n";
    
    print "<p align=center><table width=500 border=0 cellpadding=0
cellspacing=0><tr><td>\n";
    
    print "$man_edit<br></td></td></table>\n";
    
    print "<FORM action=$myscript method=\"POST\" enctype=\"multipart/form-data\">\n";
    
    print "<TEXTAREA name=thetext rows=20 cols=80>\n";
    
    if($thetext) {
	print $thetext;
    }
    else {
	open(MYFILE,$myfile) or die "Cannot open file: $!";
 @allfile = <MYFILE>;
	print @allfile;
	close(MYFILE) or die "Cannot close file: $!";
    }
    
    print "</TEXTAREA>";
    
    print "<br>\n";
    
    print "<INPUT type=submit name=query value=Preview>\n";
    print "<INPUT type=submit name=query value=Revert>\n";
    print "</FORM>\n";
    
    print "</BODY> </HTML>\n";

}

#You need this using require
return 1;
